/*
 * Copyright (c) 2005, 2006 Sharp Corporation
 */

#include "shdfb_gfx.h"

#include <core/system.h>

extern DisplayLayerFuncs  tShdfbOldPrimaryFuncs;
extern void *pShdfbOldPrimaryDriverData;

static DFBResult
shdfbYUVPortraitInitLayer (CoreLayer *ptLayer,
                    void *pDriver_data,
                    void *pLayer_data,
                    DFBDisplayLayerDescription *ptDescription,
                    DFBDisplayLayerConfig *ptConfig,
                    DFBColorAdjustment *ptAdjustment)
{
    DFBResult tRet;
    dShdfbDriverData_t *ptDriver = (dShdfbDriverData_t *) pDriver_data;
    int32 iRet = 0, iWidth;
	
    tRet = tShdfbOldPrimaryFuncs.InitLayer (ptLayer, pShdfbOldPrimaryDriverData, pLayer_data, ptDescription, ptConfig, ptAdjustment);
	if (tRet) {
		return tRet;
	}

	ptDescription->caps = DLCAPS_SURFACE;
    ptDescription->type = DLTF_GRAPHICS | DLTF_STILL_PICTURE;
    snprintf(ptDescription->name, DFB_DISPLAY_LAYER_DESC_NAME_LENGTH, "SHDFB YUV Portrait plane");

    ptDescription->caps |= DLCAPS_ALPHACHANNEL;
    ptConfig->pixelformat = YUV_PLANE_FORMAT;
   	iWidth = ptConfig->width;
   	ptConfig->width = ptConfig->height;
   	ptConfig->height = iWidth;
  
#ifndef EMULATION                          
	if (ptDriver->tYUVAddr.pdvAddr == NULL) {  
	    iRet = iLnxDFBInitYUV (&ptDriver->tYUVAddr);                      
	}
#else
	iRet = 0;
#endif    

    return iRet == 0 ? DFB_OK : DFB_FAILURE;
}

DisplayLayerFuncs tShdfbYUVPortraitFuncs = {
    LayerDataSize:      shdfbYUVdatasize,
    InitLayer:          shdfbYUVPortraitInitLayer,
    SetRegion:          shdfbSetRegion,
    RemoveRegion:        shdfbRemoveRegion,
    TestRegion:         shdfbYUVTestRegion,
    AllocateSurface: shdfbYUVAllocateSurface,
    ReallocateSurface: shdfbReallocateSurface,
};
